//#include <windows.h>
#include <stdio.h>
#include <tchar.h>

//#import "..\\..\\bin\\pdfshell.exe" no_namespace
#import "..\\..\\bin\\pdfshell.exe"

int _tmain(int argc, _TCHAR* argv[])
{
	::CoInitialize(NULL);

	CLSID clsid;
	HRESULT hr;
	pdfshell2::_shellExe *pdfptr;
	hr = CLSIDFromProgID(OLESTR("pdfshell2.shellExe"),&clsid);
	if (FAILED(hr))
	{
		return -1;
	}
	hr = CoCreateInstance(clsid,NULL,CLSCTX_LOCAL_SERVER,__uuidof(pdfshell2::_shellExe),(LPVOID *)&pdfptr);
	if (FAILED(hr))
	{
		return -2;
	}

	char szOutPDFFile[MAX_PATH];
	strcpy(szOutPDFFile, "C:\\out.pdf");
	int id = pdfptr->com_VeryCreate(szOutPDFFile);
	pdfptr->com_VeryAddInfo(id, "Title", "Subject", "Author", "Keywords", "Creator");
	char szFileName[MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	GetModuleFileName(NULL,szFileName,MAX_PATH);
	_splitpath(szFileName, drive, dir, fname, ext );
	_makepath(szFileName, drive, dir, "multipage", ".tif");
    int nRet = pdfptr->com_VeryAddImage(id, szFileName);	
    pdfptr->com_VeryClose(id);
	
	//Show a TIFF file and a PDF file
	{
		id = pdfptr->com_ImageStampOpen(szOutPDFFile,szOutPDFFile);
		if(id < 0)
			return 0;
		struct pdfshell2::BITMAPINFOHEADER bmbi;
		pdfptr->com_ImageStampGetInfo(id, &bmbi);
		//Show PDF file on an output-device
		HDC hDC = GetDC(NULL);
		struct pdfshell2::RECT destRect = {0,0,200,200};
		struct pdfshell2::RECT srcRect;
		srcRect.left = 0;
		srcRect.top = 0;
		srcRect.right = bmbi.biWidth;
		srcRect.bottom = bmbi.biHeight;
		//pdfptr->com_ImageStampShow(id,(long)hDC,&destRect,&srcRect);
		
		pdfptr->com_VeryShellPrintPDFFileTimeOut(2*1000);  //Check Printing status after 2 seconds
		pdfptr->com_VeryShellPrintPDFFileMargins(50);      //Set the margins to 50 point
		//Print Current PDF file
		pdfptr->com_ImageStampSetPageRange(id,"2,5"); //You can print a special page range at here
		pdfptr->com_ImageStampPrintEx(id,"docPrint",DMORIENT_LANDSCAPE,DMPAPER_A4,3,0);
		//Close PDF file and doesn't change anything
		pdfptr->com_ImageStampCloseAndNotSave(id);
	}
	pdfptr->Release();//Release
	
	::CoUninitialize();
	return 0;
}

